<template>
  <FormHeader
    icon="mdi-shield-check"
    headline="Безопасность"
    subtitle="Введите PIN"
  />

  <section class="pt-4">
    <FormRow>
      <PinInput v-model="pin" />

      <Feedback
        :message="feedback"
        type="error"
        classes="mt-4"
      />
    </FormRow>

    <FormRow>
      <v-btn
        block
        rounded
        size="large"
        class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
        :class="{ 'opacity-50': pin.length < 4 }"
        :readonly="pin.length < 4"
        :loading="isLoading"
        @click="onLoginClick"
      >
        Войти
      </v-btn>
    </FormRow>

    <FormRow>
      <v-btn
        block
        rounded
        size="small"
        variant="plain"
        :ripple="false"
        class="font-bold"
        @click="onAccountChange"
      >
        Сменить аккаунт
      </v-btn>
    </FormRow>

    <FormRow spacing="large">
      <Copyright />
    </FormRow>
  </section>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useRouter } from 'vue-router';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';

import PinInput from '@/components/content/PinInput.vue';
import Copyright from '@/components/content/Copyright.vue';
import Feedback from '@/components/content/Feedback.vue';

import { useAuth } from '@/composables';
import { HttpClient } from '@/http';

const emit = defineEmits(['accountChange']);

const auth = useAuth();
const router = useRouter();

const isLoading = ref(false);
const feedback = ref('');

const pin = ref('');

const onAccountChange = () => {
  auth.removeAccount();
  emit('accountChange');
};

const onLoginClick = async () => {
  isLoading.value = true;
  feedback.value = '';

  const { data: { values: account, error } } = await HttpClient.post<IAuthorizedUser>(
    '/v1/auth/login',
    { login: auth.getLogin(), pin: pin.value },
  );

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  if (!account) {
    feedback.value = (
      'Что-то не так с ответом от сервера. Попробуйте перезагрузить страницу'
    );

    return;
  }

  auth.login({
    id: account.id,
    login: account.login,
    accessToken: account.accessToken,
  });

  router.push('/dashboard');
};
</script>